typedef struct {
	int EntryCount;
	char* Entrys[6];
	int BiggestEntry;
	int EntrySizes[4];
} tMenu;


tMenu menu[5] = {
	{ 4, {" File", " Edit", " Search", " Tools" } }, //, {5, 7, 6, 5}
	{ 4, {" New text", " Open file", " Save as...", " Exit SimpleEdit" } },
	{ 6, {	" Cut          STRG+X",
		" Copy         STRG+C",
		" Insert       STRG+V",
		" Delete       STRG+D",
		" Start Block  STRG+S",
		" End Block    STRG+E"} },
	{ 2, {	" Search for...   STRG+F",
		" Search again    STRG+G" } },
	{ 2, {" Execute shell command", " Reset Mouse"} },
//	{ 1, {" Help"} }
};

char tool_buffer[100];

void ProcessMenus()
{
	int i,j;
	for( i=1; i<=menu[0].EntryCount; i++)
	{
		menu[i].BiggestEntry=0;
		for( j=0; j<menu[i].EntryCount; j++ )
			if( v2_strlen(menu[i].Entrys[j])>menu[i].BiggestEntry)
				menu[i].BiggestEntry = v2_strlen(menu[i].Entrys[j]);
	}
}

// Required for mouse-hit-detection
int SubMen_x;
int SubMen_y;
int SubMen_w;
int SubMen_h;

void DisplaySubMenu(int x, int y, int menuNR, int marked)
{
	int i;
	int col;
	int size;

	Window( x, y, menu[menuNR].BiggestEntry+3, menu[menuNR].EntryCount+1, 15+16*8, "", 0, 1 );

	SubMen_x = x;
	SubMen_y = y;
	SubMen_w = menu[menuNR].BiggestEntry+3;
	SubMen_h = menu[menuNR].EntryCount+1;

	for( i=0; i<menu[menuNR].EntryCount; i++ )
	{
		if(i==marked) col=2+16*5; else col=1+16*8;

		size=v2_strlen(menu[menuNR].Entrys[i]);

		LineOut( menu[menuNR].Entrys[i], y+1+i, col, x+1, menu[menuNR].BiggestEntry+1);

		if(i==marked)
		{
			PutChar( x+1, y+1+i, 231, 8+16*5 );
			PutChar( menu[menuNR].BiggestEntry+x+2, y+1+i, 232, 5+16*8 );
		}
	}
}

void DisplayMainMenu(int marked, int markedsub)
{
	int i;
	int col;
	int pos=2;
	int size;

	for( i=0; i<menu[0].EntryCount; i++ )
	{
		if(i==marked) col=2+16*5; else col=1+16*15;

		size=v2_strlen(menu[0].Entrys[i]);

		LineOut(menu[0].Entrys[i], 55, col, pos, size);
		if(i==marked) 
		{
			PutChar( pos, 55, 231, 15+16*5 ); //TODO: find better colors! 15+16*2
			PutChar( pos+size, 55, 232, 5+16*4 ); // 5 + 26*2
		}

		if(i==marked) DisplaySubMenu(pos, 0, i+1, markedsub);
		pos+=size+1;
	}
}

void Error(char* errstr)
{
	Status_text = errstr;
	Status_color = status_color_error;
	Display(1);

	if(getkey()==27) getkey(); // v2os returns 2 chars if ESC was pressed (at leats my version)

	Status_color = status_color_normal;
	Status_text = "";
	Display(0);
}

void Text_StartMarkation()
{
	if( c_x<GetLineLength( c_y ) ) Mark_Start = GetLineStart( c_y ) + c_x;
		else Mark_Start = GetLineStart( c_y ) + GetLineLength( c_y );	
}

void Text_EndMarkation()
{
	if( c_x<GetLineLength( c_y ) ) Mark_End = GetLineStart( c_y ) + c_x;
		else Mark_End = GetLineStart( c_y ) + GetLineLength( c_y );
}

int Text_Copy() // int because we use it in Text_cut
{
	int size;

	if( Mark_Start>Mark_End ) return 0;
	if( (Mark_Start==-1) | (Mark_End==-1 ) ) return 0;

	size=Mark_End-Mark_Start+1; // amount of data to be copied

	if( size>=BB_MaxSize)
	{
		Error(" BackBuffer isn't large enough to handle that big block! (press any key...)");
		return 0;
	}

	MemCopy( TB_ptr + Mark_Start, BB_ptr, size );
	BB_UsedSize=size;
	return 1;
}

void Text_Delete()
{
	int size;

	if( Mark_Start>Mark_End ) return;
	if( (Mark_Start==-1) | (Mark_End==-1 ) ) return;

	size=Mark_End-Mark_Start+1; // amount of data to be deleted
	
	MoveMemory( Mark_Start, size, 1 );

	ProcessLines(); // hehe, a nasty trick to make that easy...simply do all processing stuff again...
			// is maybe a bit slow with big texts, but I don't have the time to implement a better method (yet)

	Mark_Start = 0;
	Mark_End = -1;
}

void Text_Cut() 
{
		// simply copy+delete the text...
	if( Text_Copy()==0 ) return;
	Text_Delete();	
}

void Text_Insert()
{
	int size1, pos, i;

	if( BB_UsedSize==0 ) return;

	while( text_size+SecurityDistance+BB_UsedSize > TB_size )
		AllocAdditionalBuffer( 0x8000 ); // == 32K

	if( c_x>GetLineLength( c_y ) ) size1 = c_x-GetLineLength( c_y ); // in case the cursor is on a "dead char"
		else size1=0;

	text_size+=BB_UsedSize+size1;

	pos=GetLineStart( c_y ) + c_x;

	MoveMemory( pos, BB_UsedSize+size1, 0 );

	MemCopy( BB_ptr, TB_ptr+pos, BB_UsedSize );

	for( i=0; i<size1; i++ )
		SetChar( pos-i-1, ' ' );

	ProcessLines();
}

void Tools_Run()
{
	RestoreDisplay();
	
	puts("\r\n WARNING: This is still an experimental feature, handle with care!\r\n");
	puts(" Please enter the shell-command that should be executed: ");
	gets(&tool_buffer[0]);
	puts("\r\n");
	
	shell_command(&tool_buffer[0]);

	puts("\r\n");
	puts(" <-- Press any key to return to SimpleEdit -->");
	getkey();
	puts("\r\n");
	InitDisplay();
	Display(1);
}

int EnterString(char* title, char* status, char* buffer)
{
	int length; //, pos
	unsigned char c;
	char* bufpos = buffer;

	Status_text = status; //" Please enter a Filename or press ESC to cancel operation";
	Status_color = status_color_normal;

	Display(1);

	Window( 20, 18, 40, 2, 15+16*8, title, 0, 1 );	
	
//	pos=0;
	length=0;
//	file_name[0]=0;
	*buffer=0;

	for(;;)
	{
		//LineOut( &file_name[0], 22, 15+16*8, 21, 38 );
		LineOut( buffer, 19, 15+16*8, 21, 38 );
		c='*';
		PutChar( 21+length, 19, c, 0+16*2 );

		do {
			UpdateMousePos();
			c=getkey_nowait();
		} while (c==0);

		if( (c>31)&(c<128) ) {*bufpos=c; bufpos++; length++; *bufpos=0; }
		else
		switch(c)
		{
			case 8: if(length>0) {bufpos--; length--; *bufpos=0; }
				break;
			case 27: getkey(); return 0;
		}
		if(c==13) break;
		if(length>38) {bufpos--; length--; }
	}

	return 1;
}

char SearchString[40];
int SearchPos=-1;

int SearchForString(int StartPos)
{
	int i,j,k;

	k=v2_strlen( SearchString );
	
	j=k+10; // in case text_size=0

		// This is the slowest searching-rutine I ever wrote...Need to update that!!
		//  (maybe somebody out there who wants to write it in ASM??)

	for( i=StartPos; i<text_size; i++ )
	{
		for( j=0; j<k; j++ )
		{
			if( GetChar(i+j)!=SearchString[j] )
				{ j=k+10; break; }
		}
		if( j!=k+10 ) break;
	}
	if( j!=k+10 ) return i;
		else return -1;
}

void Text_Search( int new )
{
	int j;

	if( new==1 )
		if( 0==EnterString( "Search for", " Enter String to search for, press ESC to cancel", &SearchString[0] ) )
			return;

	if( (new==0)&(SearchPos==-1) ) // Try not to continue a search that's already finished!
		return;

	if( new==1) SearchPos=SearchForString( 0 );
		else SearchPos=SearchForString( SearchPos+1 );

	if( -1 != SearchPos )
	{
		for( j=0; (j<line_count) & (GetLineStart(j)<=SearchPos); j++ ); // Search the Line

		c_y=j-1;
		if( c_y<0 ) c_y=0; // shouldn't happen
		c_x=SearchPos - GetLineStart(c_y);

		CheckCursorVisible();

//		Error(" String found (press any key to continue)");

	} else
	{
		Error(" The searched String couln't be found. (press any key to continue)");
	}
}


void Text_Save()
{
	if( 0==EnterString("Save File", " Enter filename or press ESC to cancel", &file_name[0]) ) return;

	if( GetFileInfo()==1 )
	{
		Error(" File already exists, cannot overwrite files! (Press any key to continue)");
		return;
	}

	if( 0!=CreateFile( text_size ) )
	{
		Error(" Error while creating file! (Press any key to continue)");
		return;
	}

	if( GetFileInfo()!=1 )
	{
		Error(" Error: Couldn't find created file! (Press any key to continue)");
		return;		
	}
	if( (text_size/512)+1 != file_sector_count )
	{
		Error(" Error: File size mismatch! (Press any key to continue)");
		return;		
	}

	SaveFile();
}


void Text_New()
{
	line_count=1;
	text_size=1;
	text_style=0;

	SetLineLength(0, 0);
	SetLineStart(0, 0);

	c_x=0;
	c_y=0;
	file_name[0]=0;

	SetChar(0, 0);
	SetChar(1, 0);
	
//	Mark_ismarked=0;
	Mark_Start = 0; // Don't use -1, because Mark_End might be 5, Mark_Start -1 and that would confuse text_delete
	Mark_End = -1;
}

void Text_Load()
{
	if( 0==EnterString("Open File", " Enter filename or press ESC to cancel", &file_name[0]) ) return;

	if( GetFileInfo()!=1 )
	{
		Error(" File not found error! (Press any key to continue)");
		Text_New();		
		return;
	}

	if( file_rawlength+SecurityDistance>TB_size )
		AllocAdditionalBuffer( file_rawlength+SecurityDistance-TB_size );

	LoadFile();
	ProcessLines();

	c_x=0;
	c_y=0;
}

int ProcessCommand(int mx, int my)
{
	switch(mx*16+my)
	{
	case 0x00 :
		Text_New();
		return 1; //new
	case 0x01 :
		Text_Load();
		return 1;
	case 0x02 :
		Text_Save();
		return 1;
	case 0x03 : 
		return 0; //quit

	case 0x10 : //Cut
		Text_Cut();
		return 1;
	case 0x11 : //Copy
		Text_Copy();
		return 1;
	case 0x12 : // Insert
		Text_Insert();
		return 1;
	case 0x13 : //delete
		Text_Delete();
		return 1;
	case 0x14 : // Start Block
		Text_StartMarkation();
		return 1;
	case 0x15 : // Start Block
		Text_EndMarkation();
		return 1;

	case 0x20 : //Search
		Text_Search( 1 );
		return 1;
	case 0x21 : //continue search
		Text_Search( 0 );
		return 1;

	case 0x30 :
		Tools_Run();
		return 1;
	case 0x31 :
		Mouse_Init();
		return 1;
	}
	return 2; //?? error??
}

int mx=0, my=0;

// Return-codes: 0=End program  1=End Menu  2=Keep menu,repaint all  3=Keep menu, repaint menu only 4==??
int MakeMenuChar( unsigned char c)
{
	switch(c)
	{
	case '2': my=(my+1)%menu[mx+1].EntryCount; return 3;
	case '8': my=(my-1+menu[mx+1].EntryCount)%menu[mx+1].EntryCount; return 3;
	case '4': mx=(mx-1+menu[0].EntryCount)%menu[0].EntryCount; my=0; return 2;
	case '6': mx=(mx+1)%menu[0].EntryCount; my=0; return 2;
	case 13 : return ProcessCommand( mx, my );
	case 27 : return 1;
	} //switch()

	return 4;
}

// Return: 1 if klick was not successful, 0 if it was

int MakeMenuKlick( int event ) //MainMenu=1 if Menu-bar was klicked
{
	int i,pos,size;

	if( Mouse_Y==0 )
	{
		pos=2;
		for( i=0; i<menu[0].EntryCount; i++ )
		{
			size=v2_strlen(menu[0].Entrys[i]);
			if( (Mouse_X>=pos) & (Mouse_X<=pos+size) )
			{
				mx=i;
				my=0;
				return 4;
			}
			pos+=size+1;
		}
		return 1; // no hit
	} else
	{	// we can be sure that the menu has the "trigger"
		if( (Mouse_X>SubMen_x)&(Mouse_Y-1>SubMen_y)&(Mouse_X<SubMen_x+SubMen_w)&(Mouse_Y-1<SubMen_y+SubMen_h) )
		{
			my=Mouse_Y-1-SubMen_y-1;
			if( (event==3)&(Mouse_Buttons==0) )
				return ProcessCommand( mx, my )+10;
			else return 2;
		}
			// test if the border was hit
		if( (Mouse_X>=SubMen_x)&(Mouse_Y-1>=SubMen_y)&(Mouse_X<=SubMen_x+SubMen_w)&(Mouse_Y-1<=SubMen_y+SubMen_h) )
			return 1;
		else return 5;
	}
}
